
-- # import nat

data Vec (A : Set) : Nat -> Set where
  nil  : Vec A zero
  cons : (n : Nat) -> A -> Vec A n -> Vec A (suc n)

data (×) (A,B : Set) : Set where
  pair : A -> B -> A × B

-- zip

zip : (A, B : Set) -> (n : Nat) ->
      Vec A n -> Vec B n -> Vec (A × B) n
zip A B 0 nil nil = nil
zip A B (suc n) (cons n x xs) (cons n y ys)
  = cons n (pair x y) (zip A B n xs ys)

